/********************
 * 2004 Jalview Reengineered
 * Barton Group
 * Dundee University
 *
 * AM Waterhouse
 *******************/

package jalview.appletgui;

import jalview.jbappletgui.GCutAndPasteTransfer;
import jalview.datamodel.*;
import jalview.io.*;
import java.awt.*;
import java.awt.event.*;

public class CutAndPasteTransfer extends GCutAndPasteTransfer
{
  public CutAndPasteTransfer(boolean forImport)
  {
    super();

    if(!forImport)
    {
      buttonPanel.setVisible(false);
    }
  }


  public String getText()
  {
    return textarea.getText();
  }

  public void setText(String text)
  {
    textarea.setText(text);
  }


  protected void ok_actionPerformed(ActionEvent e)
  {
    String text = getText();
    SequenceI[] sequences = null;

    String format = IdentifyFile.Identify(text, "Paste");
    sequences = FormatAdapter.readFile(text, "Paste", format);

    if (sequences != null)
    {
      AlignFrame af = new AlignFrame(new Alignment(sequences));
      jalview.bin.JalviewLite.addFrame(af, "Cut & Paste input - " + format,
                                       AlignFrame.NEW_WINDOW_WIDTH,
                                       AlignFrame.NEW_WINDOW_HEIGHT);
      af.statusBar.setText("Successfully pasted alignment file");
    }

    Frame frame = (Frame)this.getParent();
    frame.setVisible(false);
   }

   protected void cancel_actionPerformed(ActionEvent e) {
     Frame frame = (Frame)this.getParent();
     frame.setVisible(false);
   }




}
